/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 2.01  */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Local headers */
#include "ablibs.h"
#include "abimport.h"
#include "proto.h"
#include "playlist.h"

extern int current_song, selected_song;

int
BtnPlay( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

{
	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	if (is_playing())
	{
		/*
		 * If the currently playing track is selected, or no track
		 * is selected but one is playing, the play button does nothing.
		 */
		if (selected_song < 0 || selected_song == current_song)
		{
			if (is_paused())
				toggle_pause();

			return (Pt_CONTINUE);
		}

		/*
		 * Another track is selected, so jump to it.
		 */
		current_song = selected_song;
		start_playing(current_filename());
	}
	else
	{
		/*
		 * If a song is selected, start with it.
		 */
		if (selected_song > 0)
			current_song = selected_song;
		else
			current_song = random() % nsongs;
		order_tracks();
		start_playing(current_filename());
	}

	return( Pt_CONTINUE );
}
