/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 2.01  */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "abimport.h"
#include "proto.h"
#include "playlist.h"
#include "gfuncs.h"

extern int save_on_exit, default_list_mode, use_replaygain;
extern char *default_list, *starting_dir;
extern double add_decibels;

int
BtnSettingsOK( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

{
	unsigned long	*flags;
	unsigned short	*item;
	char		*text;

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	PtGetResource(ABW_AutoSaveToggle, Pt_ARG_FLAGS, &flags, 0);
	save_on_exit = (*flags & Pt_SET) != 0;

	PtGetResource(ABW_CoverFilenamesText, Pt_ARG_TEXT_STRING, &text, 0);
	text_to_cover_filenames(text);

	PtGetResource(ABW_ReplayGainToggle, Pt_ARG_FLAGS, &flags, 0);
	use_replaygain = (*flags & Pt_SET) != 0;

	PtGetResource(ABW_DefaultListCombo, Pt_ARG_CBOX_SEL_ITEM, &item, 0);
	default_list_mode = *item - 1;

	PtGetResource(ABW_AddDecibelsText, Pt_ARG_TEXT_STRING, &text, 0);
	if (text != NULL)
		add_decibels = atof(text);

	PtGetResource(ABW_DefaultListText, Pt_ARG_TEXT_STRING, &text, 0);
	if (default_list != NULL)
		free(default_list);
	default_list = gstrdup(text);

	PtGetResource(ABW_StartingDirectoryText, Pt_ARG_TEXT_STRING, &text, 0);
	if (starting_dir != NULL)
		free(starting_dir);
	starting_dir = gstrdup(text);

	prefs_write();

	return( Pt_CONTINUE );

}
