/* Generic event handler.  Right now this is used for    */
/* the keyboard events generated by the Audrey's channel */
/* wheel.                                                */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 2.01  */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>
#include <photon/keycodes.h>

/* Local headers */
#include "abimport.h"
#include "proto.h"
#include "playlist.h"

int
HandleEvent( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

{
	PhEvent_t	*event = (PhEvent_t *)cbinfo->event;

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	if (event == NULL)
		return (Pt_CONTINUE);

	if (event->type == Ph_EV_KEY)
	{
		PhKeyEvent_t	*key;

		key = (PhKeyEvent_t *) PhGetData(event);

		if (key->key_flags & KEY_DOWN)
		{
			switch (key->key_sym) {
			case 0xf0c6:		// wheel turned left
				BtnPrev(widget, apinfo, cbinfo);
				break;

			case 0xf0c7:		// wheel turned right
				BtnNext(widget, apinfo, cbinfo);
				break;

			case 0xf0c8:		// wheel pressed in
				if (is_playing())
					BtnPause(widget, apinfo, cbinfo);
				else
					BtnPlay(widget, apinfo, cbinfo);
				break;
			}
		}
	}

	return( Pt_CONTINUE );

}

