/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 2.01  */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "abimport.h"
#include "proto.h"
#include "playlist.h"
#include "gfuncs.h"


extern int save_on_exit, search_for_covers, default_list_mode, use_replaygain;
extern char *default_list, *starting_dir;
extern double add_decibels;

int
SettingsInit( PtWidget_t *link_instance, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

{
	char	db[30];
	char	*cover_names = cover_filenames_to_text();

	/* eliminate 'unreferenced' warnings */
	link_instance = link_instance, apinfo = apinfo, cbinfo = cbinfo;

	PtSetResource(ABW_AutoSaveToggle, Pt_ARG_FLAGS,
			save_on_exit ? Pt_TRUE : Pt_FALSE, Pt_SET);
	PtSetResource(ABW_CoverFilenamesText, Pt_ARG_TEXT_STRING,
			cover_names, 0);
	PtSetResource(ABW_ReplayGainToggle, Pt_ARG_FLAGS,
			use_replaygain ? Pt_TRUE : Pt_FALSE, Pt_SET);

	sprintf(db, "%.1f", add_decibels);
	PtSetResource(ABW_AddDecibelsText, Pt_ARG_TEXT_STRING,
			db, 0);
	PtSetResource(ABW_DefaultListText, Pt_ARG_TEXT_STRING,
			default_list, 0);
	PtSetResource(ABW_StartingDirectoryText, Pt_ARG_TEXT_STRING,
			starting_dir, 0);
	
	PtSetResource(ABW_DefaultListCombo, Pt_ARG_CBOX_SEL_ITEM,
			default_list_mode + 1, 0);

	gfree(cover_names);
	return( Pt_CONTINUE );
}
