/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 2.01  */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/time.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "abimport.h"
#include "proto.h"
#include "playlist.h"


extern int current_song, selected_song;

int
SongSelected( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )

{
	PtListCallback_t	*listinfo = (PtListCallback_t *) cbinfo->cbdata;
	static struct timeval	last_click_time = { 0, 0 };
	struct timeval		now, diff;

	selected_song = listinfo->item_pos - 1;

	/*
	 * See if the user double-clicked on a track, and start playing it
	 * if so.  cbinfo->reason_subtype is 0 for button up, 1 for button
	 * down, so we get a pair of them on each click.  Trigger on the
	 * button-down events.
	 */
	if (cbinfo->reason_subtype)
	{
		gettimeofday(&now, NULL);
		timersub(&now, &last_click_time, &diff);
		if (diff.tv_sec == 0 &&
		    diff.tv_usec < DOUBLECLICK_TIME_MS * 1000)
		{
			current_song = selected_song;
			start_playing(current_filename());
		}

		last_click_time = now;
	}

	return( Pt_CONTINUE );

}
