/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 2.01  */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/mman.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "abimport.h"
#include "proto.h"
#include "playlist.h"
#include "gfuncs.h"

/* Application Options string */
const char ApOptions[] =
	AB_OPTIONS ""; /* Add your options in the "" */

char *starting_dir = NULL;

extern char *native_charset, *fs_charset;
extern char *prefs_file;
extern char *default_list;

void
usage(char *name)
{
	printf("Usage: %s [-x|y|w|h num] [-f config-file] [starting-dir]\n", name);
	exit(1);
}

int
StartMadplay( int argc, char *argv[] )
{
	int c;

	prefs_init();

	while ((c = getopt(argc, argv, "S:x:y:w:h:f:")) != EOF)
		switch (c) {
		case 'S':
		case 'x':
		case 'y':
		case 'w':
		case 'h':
			// Handled by PhAB code
			break;

		case 'f':
			prefs_file = optarg;
			break;
		case '?':
			usage(argv[0]);
			break;
		}

	if (phjuke_is_running())
		PtExit(1);

	prefs_read();

	if (argc > optind)
		starting_dir = gstrdup(argv[optind++]);
	if (starting_dir == NULL)
	{
		starting_dir = gmalloc(PATH_MAX + 1);
		if (getcwd(starting_dir, PATH_MAX + 1) == NULL)
		{
			perror("Can't determine starting directory");
			PtExit(1);
		}
	}
	
	srandom(getpid() + time(NULL));

	return( Pt_CONTINUE );
}

