/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 2.01  */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "abimport.h"
#include "proto.h"
#include "playlist.h"

extern char *starting_dir;
extern char *default_list;
extern int default_list_mode;

int
WinOpen( PtWidget_t *link_instance, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )
{
	unsigned short	*width;

	/* eliminate 'unreferenced' warnings */
	link_instance = link_instance, apinfo = apinfo, cbinfo = cbinfo;

	init_loading_dialog();
	init_browsepane();
	jump_to(starting_dir, 0);

	/*
	 * Work around a Photon bug -- it doesn't scoot oversized list
	 * scrollbars to the left, so their right sides get clipped.
	 * This should be a harmless workaround once the bug is fixed.
	 */
	PtGetResource(ABW_PlayList, Pt_ARG_WIDTH, &width, 0);
	PtSetResource(ABW_PlayList, Pt_ARG_WIDTH, *width - 10, 0);
	PtSetResource(ABW_PlayList, Pt_ARG_SCROLLBAR_WIDTH, 25, 0);
	PtGetResource(ABW_PlayList, Pt_ARG_WIDTH, &width, 0);
	PtSetResource(ABW_PlayList, Pt_ARG_WIDTH, *width + 10, 0);

	/*
	 * Set up the initial states of the checkboxes.
	 */
	BtnRepeat(NULL, NULL, NULL);
	BtnShuffle(NULL, NULL, NULL);
	MenuAutoClear(NULL, NULL, NULL);

	init_play_controls();

	if (default_list != NULL && default_list_mode > 0)
		launch_file(default_list, default_list_mode == 2);

	return( Pt_CONTINUE );
}

