/*
 * We know about these types of files.
 */
typedef enum {
	DIRECTORY = 0,
	PLAYLIST = 1,
	PHJ = 2,
	TRACK = 3,		// mp3, ogg, etc.
	LABEL = 4		// A placeholder, for browser labels
} FILE_TYPE;

/*
 * For every file in the playlist or in the browser, we have one of these
 * structures.  All strings are malloced.
 */
typedef struct {
	/* Full path to the file, in filesystem charset. */
	char		*path;

	/* Displayable name, in UTF8. */
	char		*name;

	/* Length in seconds (valid for type = TRACK). */
	int		length;

	/* What kind of file this is. */
	FILE_TYPE	type;
} FILE_INFO;

