#ifndef __GFUNCS_H__
#define __GFUNCS_H__ 1

/*
 * Guarded functions for memory allocation, etc.
 */
void *gcalloc(int size);
void *gmalloc(int size);
char *gstrdup(char *str);
void *grealloc(void *ptr, int size);
int   endswith(const char *str, const char *suffix);
void  gstrncpy(char *dest, char *src, int len);
void  gfree(void *ptr);


int strcasecmp(const char *, const char *);
int strncasecmp(const char *, const char *, int);

void *arena_create(int initial_size);
void *arena_malloc(void *varena, int size);
void  arena_destroy(void **varena);
char *arena_strdup(void *varena, char *str);
void *arena_calloc(void *varena, int size);

#endif
