#include <stdio.h>

// Time within which a double-click has to happen (playlist, save dialog)
#define DOUBLECLICK_TIME_MS	700

void launch_file(char *filename, int play);
void clear_list();
void add_to_list(char *directory, char *filename, char *title, int update_widget);
void add_filename_to_list(char *filename, int update_widget);
char *next_track();
char *previous_track();
char *current_filename();
void order_tracks();
void delete_track();
void save_list(char *directory, char *filename);

void add_cover_filename(char *filename);
char *cover_filenames_to_text();
void text_to_cover_filenames(char *text);

int  load_m3u(char *filename, int update_widget);
void *m3u_create(char *directory, char *filename);
int  m3u_write(void *m3u, char *title, char *filename);
void m3u_close(void *m3u);

int  load_txt(char *filename, int update_widget);
int  check_txt(const char *filename);

char *get_current_dir(void);
void jump_to(char *filename, int add_to_history);
void jump_back(void);
void add_all_mp3s(void);

int  start_playing(char *filename);
void stop_playing();
int  is_playing();
void toggle_pause();
int  is_paused();

void set_back_button(int enabled);
void set_add_tracks_menu(int enabled);
void set_menu_item(int item, int enabled);
void set_play_controls(void);
void show_loading_dialog(char *message, int entries);
void hide_loading_dialog(void);
void init_loading_dialog(void);
void init_play_controls(void);
void init_browsepane(void);

void map_dir(char *);
void add_map_dir(char *);
void print_map_dirs(FILE *);

int  native_to_utf8(char *str, int maxlen);
int  fs_to_utf8(char *str, int maxlen);
int  utf8_to_native(char *str, int maxlen);
int  utf8_to_fs(char *str, int maxlen);

void prefs_init(void);
void prefs_read(void);
void prefs_write(void);

int  network_init(int port);
int  get_port(void);

int  phjuke_is_running(void);

/*
 * For each playlist entry, we know the filename and possibly some other
 * additional information.
 */
typedef struct {
	char	*filename;	// Filename relative to app working directory
	char	*title;		// Title to display in playlist
} SONG;

extern SONG *songs;		// Current playlist
extern int nsongs;		// Size of playlist
